
#import <Foundation/Foundation.h>

@interface Test : NSObject
- (void)lock;
- (void)lock:(NSConditionLock *)lock;
@end

@implementation Test

- (void)lock
{
    NSConditionLock *lock = [[NSConditionLock alloc] initWithCondition:0];
    
    [NSThread detachNewThreadSelector:@selector(lock:) toTarget:self withObject:lock];

    NSLog(@"Attempting lock...");
    BOOL success = [lock lockWhenCondition:1 beforeDate:[NSDate dateWithTimeIntervalSinceNow:5.0]];
    NSLog(@"Done trying to lock, success: %@", success ? @"YES" : @"NO");
}

- (void)lock:(NSConditionLock *)lock
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    [lock lock];
    [NSThread sleepForTimeInterval:10.0];
    [lock unlockWithCondition:1];
    [pool release];
}

@end

int main(int argc, char *argv[])
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    Test *test = [[Test alloc] init];
    [test lock];
    [pool release];
    return 0;
}

